====== inet-3.x ======

2017-10-02  ------ inet-3.6.2 released ------

2017-07-06  ------ inet-3.6.1 released ------

2017-06-09  ------ inet-3.6.0 released ------

2017-06-01  Zoltan Bojthe

	CID 179372 Uninitialized scalar field

2017-02-20  ------ inet-3.5.0 released ------

2017-01-09  Rudolf Hornig

    build: fixed various message files not to redefine a field on inheritance

2016-11-24  Irene Ruengeler

    Packetdrill: Add StreamReconfig support for SCTP

2016-09-22  Zoltan Bojthe

    SCTPSocket: getters made const

2016-09-22  Zoltan Bojthe

    omnetpp5: add/use refreshDisplay()

2016-07-21  Zoltan Bojthe

    tcpsocket: getState() made const

2016-06-15  ------ inet-3.4.0 released ------

2016-06-01  ------ inet-3.3.0 released ------

2016-03-30  Irene Ruengeler

	Added packetdrill SCTP support and socket options

2016-04-06  ------ inet-3.2.4 released ------

2016-03-16  ------ inet-3.2.3 released ------

2016-03-11  ------ inet-3.2.2 released ------

2016-01-21  ------ inet-3.2.1 released ------

2015-12-16  ------ inet-3.2.0 released ------

2015-10-26  ------ inet-3.1.1 released ------

2015-10-15  ------ inet-3.1.0 released ------

2015-06-22  ------ inet-3.0.0 released ------

2015-05-13  ------ inet-2.99.1 released ------

2014-12-10  Zoltan Bojthe

	Applied C++ source code modernizer.

2015-01-15  Irene Ruengeler

	Fix signatures to correct types.

2014-12-11  Levente Meszaros

	TransportLayer: Moved ITCP, IUDP, ISCTP under contract.

2014-12-04  Zoltan Bojthe

	Fixed defects found by static code analyzer (Coverity).

2014-11-14  Zoltan Bojthe

	Added socketDeleted() to TCPSocket::CallbackInterface.

2014-11-07  ------ inet-2.99.0 released ------

2014-09-18  Andras Varga

	Moved all sources under the src/inet directory, so that all #include
	statements begin with "inet/". The motivation is to rule out potential
	filename clashes when multiple model frameworks are used together.

	HINT: You can use the "opp_githist" command in inet/_scripts to find
	all previous locations of the sources in this directory, and to view
	the full history in gitk. Normal invocations of gitk can only show
	file history back to the most recent move operation.

2014-07-30  Andras Varga

	Changes on the inet-3.x branch so far:

	Directory restructuring (Rudolf Hornig):
	- contents split up to sctp/, tcp/, udp/ subdirectories

	Code formatting (Zoltan Bojthe)
	- using uncrustify, see _scripts/reformat/*
	- common style for header guards

	Namespace (Zoltan Bojthe, Zsolt Prontvai)
	- code has been moved into the inet namespace

2014-01-22  Levente Meszaros

	Moved TCP, UDP and SCTP contracts into separate directories.

====== inet-2.x ======

2015-03-04  ------ inet-2.6 released ------

2014-11-07  ------ inet-2.5.1 released ------

2014-10-29  ------ inet-2.5.0 released ------

2014-10-29  Thomas Dreibholz

	tcp: added sendCommand API to the TCP socket

2014-06-12  ------ inet-2.4.0 released ------

2014-03-19  ------ inet-2.3.0 released ------

2014-03-14  Irene Rungeler

	sctp: added SCTP NAT support

2014-01-24  Zoltan Bojthe

	backport: msg files: legacy enum(Foo) syntax changed to @enum(Foo)

2013-05-10  Tamás Borbély

	backport: UDP: add option to specify the source address of the sent
	datagram

2013-09-20  Andras Varga

	ev->EV and related OMNeT++ 5.0 logging compatible fixes

2013-08-22  ------ inet-2.2.0 released ------

2013-07-25  Tamas Borbely

	UDP: implemented ReuseAddress option (it's like SO_REUSEADDR socket
	option in Linux)

	If ReuseAddress is set to true on two sockets, then they can bind to the
	same local address/port.

	E.g. the following works:

	      UDPSocket s1, s1;
	     ...
	     s1.setReuseAddress(true);
	     s1.bind(7777);
	     s2.setReuseAddress(true);
	     s2.bind(IPv4Address("10.0.0.1"), 7777);

	s2 will receive packets whose destination address is 10.0.0.1, s1 will
	receive all other packets

2013-07-17  Irene Ruengeler

	sctp: Added 8 new strategies for stream scheduling
	- new SCTP_C_SET_STREAM_PRIO code in SctpCommandCode
	- new SCTPSocket::setStreamPriority(stream, priority) method

2013-07-17  Irene Ruengeler

	sctp: Implemented SCTP Stream Reset (RFC 6525)
	- new SCTP_C_STREAM_RESET code in SctpCommandCode
	- new SCTP_I_SEND_STREAMS_RESETTED, SCTP_I_RCV_STREAMS_RESETTED,
	  SCTP_I_RESET_REQUEST_FAILED code in SctpStatusInd
	- SCTPSocket's listen, connect, conectx now have a streamReset parameter

2013-07-10  Irene Ruengeler

	sctp: Implemented Add-IP feature for SCTP (RFC 5061)
	- new SCTP_C_SEND_ASCONF code in SctpCommandCode
	- new SCTP_I_ADDRESS_ADDED code in SctpStatusInd

2013-07-03  Irene Ruengeler

	sctp: implementation of Partial Reliability SCTP (RFC 3758)
	- new SctpStatusInd: SCTP_I_ABANDONED
	- two new SCTPSocket::send methods to support Partial Reliability related parameters
	- SCTPSocket::connect and SCTPSocket::connectx has an additional
	  Partial Reliability related parameter
	- SCTPSocket's CallbackInterface has a new method: msgAbandonedArrived(int assocId)

2013-07-02  Irene Ruengeler

	sctp: NR_SACK feature - added SCTPSendQueueAbated command

2013-04-03  Irene Ruengeler

	sctp: refactoring - getNewConnId() was renamed to getNewAssocId()

2013-01-30  ------ inet-2.1.0 released ------

2012-11-09  Zoltan Bojthe

	Improved error reporting when socket is not (yet) connected.

2012-11-08  Zoltan Bojthe

	TCPSocket: fix for incorrectly set closed state.

2012-08-07  ------ inet-2.0.0 released ------

2012-06-25  ------ inet-1.99.5 released ------

2012-06-12  Rudolf Hornig

	Code takover from INETMANET-2.0:
	UDPSocket: Added the possibility to specify the output interface when
	sending an UDP packet.

2012-03-20  ------ inet-1.99.4 released ------

2012-02-24  ------ inet-1.99.3 released ------

2012-02-09  Andras Varga

	UDPSocket: added support for IPv4 ToS and IPv6 Traffic Class

2012-01-27  Tamas Borbely

	UDPSocket: added joinLocalMulticastGroups() and leaveLocalMulticastGroups()

2012-01-27  Tamas Borbely

	UDP: generalized joinMulticastGroup() and leaveMulticastGroup() to accept
	more than one address

2012-01-31  Zoltan Bojthe

	TCPSocketMap: bugfix: clear map after deleting sockets

2012-01-31  Zoltan Bojthe

	SCTP: bugfix: inbound/outbound were mixed up

2012-01-31  Zoltan Bojthe

	transport/contract: moved files here from sctp, tcp_common and udp
	contract folders

	Contract is now always available, regardless of feature settings. This
	reduces the amount of ifdefs needed.

2011-11-18  ------ INET-1.99.2 released ------

2011-08-03  Tamas Borbely

	fix example in UDPSocket.h comment

2011-07-28  Andras Varga

	UDPSocket: removed callback support

	It didn't provide much utility value, and apparently nobody used it.

2011-07-25  Andras Varga

	Heavy API changes; added multicast, broadcast and ttl support

	Features/improvements:
	- added support for the following socket options (see Unix setsockopt()):
	  time-to-live (unicast and multicast), broadcast, multicast output
	  interface, join multicast group, leave multicast group.

	- UDPControlInfo was as a bit confusing, as it contained the union of
	  all fields needed for all commands/indications, so it was not
	  clear whether some field X was used for some command/indication,
	  and if so, what its exact role was. Specific UDPControlInfo classes
	  are now much more explicit about this.

	- UDPSocket class now contains much less state (clearer responsibilities,
	  less chance of disagreement with UDP module's view)

	Details:
	- UDPControlInfo has been split to: UDPBindCommand, UDPConnectCommand,
	  UDPSendCommand, UDPCloseCommand, and UDPDataIndication,
	  UDPErrorIndication for the opposite direction. Used with the
	  corresponding UDP_C_xxx and UDP_I_xxx message kinds.

	- UDP_C_UNBIND message kind has been renamed to UDP_C_CLOSE

	- added UDP_C_SETOPTION (for setting socket options);
	  it must be acompanied by any of: UDPSetTimeToLiveCommand,
	  UDPSetBroadcastCommand, UDPSetMulticastInterfaceCommand,
	  UDPJoinMulticastGroupCommand, UDPLeaveMulticastGroupCommand.

	- the "unspecified" port number value has been changed from 0 to -1,
	  for consistency with other parameters in the NED file

	- userId was removed, as it hasn't offered a tremendous utility
	  value, and apparently nobody used it

	UDPSocket class:
	- now it stores minimal state (practically just the socket id),
	  and everything else is immediately sent down to the UDP module
	- new methods for socket options:
	     setTimeToLive(),
	     setBroadcast(),
	     setMulticastOutputInterface()
	     joinMulticastGroup()
	     leaveMulticastGroup()
	- new utility method:
	     getReceivedPacketInfo()
	- removed methods:
	     setUserId() / getUserId() -- userId is no longer;
	     getState() / stateName() -- state is not kept;
	     getLocalAddress() / getLocalPort() -- state is not kept;
	     setMulticastInterfaceId() / getMulticastInterfaceId() -- renamed

2011-07-21  Andras Varga

	UDP, UDPSocket: documentation updated. Apparently the UDPSocket docu
	was a copy/paste of TCPSocket docu.

2011-07-19  Andras Varga

	UDPSocket: send() and sendTo() to accept cPackets only.
	Note: in UDP, cMessage with UDP_C_DATA would cause "cannot cast" anyway.

2011-07-19  Andras Varga

	cPolymorphic -> cObject (cPolymorphic became cObject in OMNeT++ 4.0)

2011-06-03  Andras Varga

	cosmetics: space usage made somewhat more consistent throughout the code

	Notes:
	- if you have an INET fork and want to compare the code, use the
	 "Ignore spaces" option of your visual diff tool. Most tools have
	 this option; Meld and Araxis Merge certainly do.

	- I used omnetpp/_scripts/tidymodel/spaces.pl, plus some manual tweaks

2011-05-30  ------ INET-1.99.1 released ------

2011-05-26  Zoltan Bojthe

	Follow change: IPAddress renamed to IPv4Address

2011-03-11  Zoltan Bojthe

	Features: contents of transport/contract/ was distributed to
	transport/tcp_common/contract, transport/udp/contract, and
	transport/sctp/contract.

2011-03-03  ------ INET-1.99.0 released ------

2011-02-28  Zoltan Bojthe

	NEDDOC: Fixes in TCP documentation

2011-01-14  Zoltan Bojthe

	TCP datatransfermode fixes

2010-05-25  Zoltan Bojthe

	Reading of "dataTransferMode" NED parameter moved into TCPSocket

2010-05-25  Andras Varga

	use TCPDataTransferMode enum instead of int; comment refinements; other
	cosmetic changes

2010-05-19  Zoltan Bojthe

	TCPSocket/TCPControlInfo: Added support for TCP transfer modes

2009-06-16  Tamas Borbely

	TCPSocket: added sendQueueClass/receiveQueueClass/tcpAlgorithm parameters

2009-03-25  ------ INET-20090325 released ------

2008-09-25  Irene Ruengeler

	Initial checkin of the SCTP code; SCTPCommand and SCTPSocket added to
	transport/contract/.

	If you are interested in the early history of the code, change
	to the project root and type

	$ gitk -- src/transport/contract INET/src/transport/contract

2008-01-01..2009-03-25  Andras Varga, Rudolf Hornig

	Porting of INET to OMNeT++ 4.0, and some general face lift:
	* better directory structure (names changed to lowercase; moved sources
	  under src/; better names, e.g. networkinterfaces -> linklayer)
	* build system to use a deep makefile
	* updated the C++ code for the 4.0 API (follow name changes; use
	  int64-based simtime_t; use cPacket; etc.)
	* NED files converted to 4.0 syntax
	* make use of new features in NED files (module interfaces, inout
	  gates, @unit, etc.)

2005-08-04  Andras Varga

	Initial checkin, into transport/contract/.

	If you are interested in the early history of the code, change
	to the project root and type

	$ gitk -- Transport/Contract INET/src/transport/contract src/transport/contract
